'DO not use WordsIn() or WordsOut() because a
'user can manually modify the content

'Compilable Example:
#Compiler PBWin 10
#Compile Exe "gbwordlist.exe"
#Debug Display On
#Debug Error On
#Dim All
%Unicode=1
#Include "Win32API.inc"
#Resource Manifest, 1, "files/xptheme.xml"
#Resource Icon, aaa, "files/gbwordlist.ico"
#Resource Icon, opentextfile, "files/open.ico"
#Resource Icon, createlist, "files/create.ico"
#Resource Icon, copylist, "files/copy.ico"
#Resource Icon, wordcount, "files/wordcount.ico"
#Resource Icon, casesensitive, "files/case.ico"
#Resource Icon, allownumeric, "files/numeric.ico"
#Resource Icon, settings, "files/settings.ico"
#Resource Icon, fonttype, "files/font.ico"
#Resource Icon, linenumber, "files/linenumber.ico"
#Resource Icon, uphand, "files/uphand.ico"
#Resource Icon, downhand, "files/downhand.ico"
#Resource Icon, saylist, "files/gbsaylist.ico"
#Resource Icon, Help, "files/help.ico"

$ver = "  v1.11"

%IDC_Source    = 500
%IDC_WordList  = 501
%IDC_StatusBar = 502
%IDC_Toolbar   = 503

%IDM_Cut    = 700
%IDM_Paste  = 701
%IDM_Copy   = 702
%IDM_Delete = 703
%IDM_Clear  = 704
%IDM_ClearBoth = 705
%IDM_SortA  = 706
%IDM_SortD  = 707
%IDM_AutoCreate = 708
%IDM_Sep    = 709
%IDM_TextExt= 710
%IDM_Stats  = 711
%IDM_Find   = 712
%IDM_Search = 713
%IDM_SearchSensitive   = 714
%IDM_Capture           = 715
%IDM_SelectLibrary     = 716
%IDM_RemoveMatching    = 717
%IDM_RemoveNonMatching = 718
%IDM_SaveAs            = 719
%IDM_SortOther         = 720
%IDM_SortAL            = 721
%IDM_SortDL            = 722
%IDM_RemoveBlanks      = 723
%IDM_Trim              = 724
%IDM_ConvertTABs       = 725
%IDM_Reload            = 726
%IDM_ShowCFN           = 727
%IDM_MatchingLines     = 728
%IDM_MatchingWords     = 729
%IDM_SetMinMax         = 730
%IDM_MinimalBinary     = 731
%IDM_MCase             = 732
%IDM_UCase             = 733
%IDM_LCase             = 734

%IDT_Open          = 800
%IDT_Create        = 801
%IDT_Copy          = 802
%IDT_WordCount     = 803
%IDT_CaseSensitive = 804
%IDT_AllowNumeric  = 805
%IDT_Settings      = 806
%IDT_Font          = 807
%IDT_LineNumbers   = 808
%IDT_SayList       = 809
%IDT_Help          = 810

%IDS_Label      = 900
%IDS_Backward   = 901
%IDS_Forward    = 902
%IDS_SearchTerm = 903
%IDS_SearchSensitive = 904

Global hDlg, hSource, hWordList, hContext, hImageList, hToolbar As Dword
Global ghHook, hFont, hPopupSettings, hSearch As Dword
Global FileContent, WordsIn(), WordsOut() As String
Global FileExtMS, FileExtHTM, FileExtBin, FontName, LibraryFileName, CurrentFileName As WStringZ * %Max_Path
Global MatchTerm,SearchTerm, INIFileName, FileFilter, AllowedChars As WStringZ * %Max_Path
Global OldProc, LineNumbers, WordCount, CaseSensitive, SearchSensitive, AllowNumeric, AutoCreate, MinimalBinary, TabConversion As Long
Global MinSize,MaxSize,FontSize, FontAttr, fDlgShown, SearchSide, SearchPos, SearchPosLeft, SearchPosRight, SortOther, ShowCFN As Long

Function PBMain() As Long
   Local style&
   style& = %WS_Child Or %WS_Visible Or %ES_MultiLine Or %WS_VScroll Or %ES_AutoHScroll _
      Or %WS_HScroll Or %ES_AutoVScroll Or %ES_WantReturn Or %WS_TabStop Or %WS_ClipSiblings 'or %ES_NoHideSel

   Dialog New Pixels, 0, "gbWordList" + $ver,300,300,500,550, %WS_OverlappedWindow Or %WS_ClipChildren, %WS_Ex_Left Or %WS_Ex_LtrReading Or %WS_Ex_RightScrollbar To hDlg
   Dialog Set Icon hDlg, "aaa"
   DragAcceptFiles hDlg, %True

   Control Add TextBox, hDlg, %IDC_Source,"Welcome to gbWordList!" + $CrLf + $CrLf + "To get results, just enter" + $CrLf + "text and press Create!" + $CrLf + $CrLf + Date$ + "      " + Time$, 10,55,240,500, Style&, %WS_Ex_ClientEdge Or %WS_Ex_Left
   Control Handle hDlg, %IDC_Source To hSource
   SendMessage hSource, %EM_SETLIMITTEXT, 10000000, 0     '10M
   Control Add TextBox, hDlg, %IDC_WordList,"",260,55,240,500, Style&, %WS_Ex_ClientEdge Or %WS_Ex_Left
   Control Handle hDlg, %IDC_WordList To hWordList
   SendMessage hWordList, %EM_SETLIMITTEXT, 10000000, 0     '10M

   Control Add Statusbar, hDlg, %IDC_StatusBar, "", 0,0,0,0
   Dialog Show Modal hDlg Call DlgProc
End Function

CallBack Function DlgProc() As Long
   Local temp$, iResult,w,h As Long, P As ToolTipText Ptr, nmtb As TBNotify Ptr, rc As Rect
   Select Case Cb.Msg
      Case %WM_InitDialog
         If IsFalse(IsFolder(Exe.Path$ + "library_files")) Then MkDir Exe.Path$ + "library_files"
         If IsFalse(IsFile(Exe.Path$ + "library_files\library.txt")) Then CreateLibraryFile
         BuildAcceleratorTable
         CreateCustomPopupMenu
         Settings_INI "get"
         SetCaption
         Font New FontName, FontSize, FontAttr To hFont
         Control Set Font hDlg, %IDC_Source, hFont
         Control Set Font hDlg, %IDC_WordList, hFont
         CreateToolbar
         SetMenusAndToolbarButtons
         OldProc = SetWindowLong(GetDlgItem(hDlg, %IDC_Source), %GWL_WndProc, CodePtr(NewProc))  'subclass
         OldProc = SetWindowLong(GetDlgItem(hDlg, %IDC_WordList), %GWL_WndProc, CodePtr(NewProc))  'subclass
         LoadPreviousSession
         FillStatusBar
         Control Set Focus hDlg, %IDC_Source
         PostMessage GetDlgItem(hDlg, %IDC_Source), %EM_SETSEL, -1, 0   'remove highlighting on startup

      Case %WM_Destroy
         SaveSession
         Settings_INI "save"
         SetWindowLong GetDlgItem(hDlg, %IDC_Source), %GWL_WNDPROC, OldProc   'un-subclass
         SetWindowLong GetDlgItem(hDlg, %IDC_WordList), %GWL_WNDPROC, OldProc   'un-subclass

      Case %WM_DropFiles
         MousePtr 11
         temp$ = GetDroppedFileName(Cb.WParam)
         DragFinish Cb.WParam
         CurrentFileName = temp$
         LoadFile
         If AutoCreate Then CreateWordList
         MousePtr 1

      Case %WM_Command
         Select Case Cb.Ctl
            Case %IDC_Source   : If Cb.CtlMsg = %EN_SetFocus Then Control Send hDlg, %IDC_Source, %EM_SetSel, 0,0
            Case %IDC_WordList : If Cb.CtlMsg = %EN_SetFocus Then Control Send hDlg, %IDC_WordList, %EM_SetSel, 0,0
            Case %IDT_Open
               SelectAndLoadFile
               SetCaption
               If AutoCreate Then CreateWordList
               FillStatusBar
               Control Set Focus hDlg, %IDC_Source
            Case %IDT_Copy
               SendMessage hWordList, %EM_GetSel, VarPtr(w), VarPtr(h)  'cursor is here
               If w = h Then
                  Control Get Text hDlg, %IDC_WordList To temp$
                  Clipboard Reset
                  Clipboard Set Text temp$
               Else
                  SendMessage GetFocus, %WM_COPY, 0, 0
               End If
            Case %IDT_Create
               CreateWordList

            Case %IDT_WordCount     : WordCount = WordCount Xor 1           : If AutoCreate Then CreateWordList
            Case %IDT_CaseSensitive : CaseSensitive = CaseSensitive  Xor 1  : If AutoCreate Then CreateWordList
            Case %IDT_AllowNumeric  : AllowNumeric = AllowNumeric Xor 1     : If AutoCreate Then CreateWordList
            Case %IDT_LineNumbers   : LineNumbers = LineNumbers Xor 1       : If AutoCreate Then CreateWordList

            Case %IDM_Cut     : SendMessage GetFocus, %WM_CUT, 0, 0     : FillStatusBar
            Case %IDM_Copy    : SendMessage GetFocus, %WM_COPY, 0, 0
            Case %IDM_Paste   : SendMessage GetFocus, %WM_PASTE, 0, 0   : FillStatusBar
            Case %IDM_Delete  : SendMessage GetFocus, %WM_CLEAR, 0, 0   : FillStatusBar
            Case %IDM_Clear   : SendMessage GetFocus, %WM_SetText, 0, 0 : FillStatusBar

            Case %IDM_UCase : ConvertCase 1
            Case %IDM_LCase : ConvertCase 2
            Case %IDM_MCase : ConvertCase 3

            Case %IDM_AutoCreate
               AutoCreate = AutoCreate Xor 1
               SetMenusAndToolbarButtons

            Case %IDM_SearchSensitive
               SearchSensitive = SearchSensitive Xor 1
               SetMenusAndToolbarButtons

            Case %IDM_ShowCFN
               ShowCFN = ShowCFN Xor 1
               SetCaption
               SetMenusAndToolbarButtons

            Case %IDM_ConvertTABs         : ConvertTABs
            Case %IDM_RemoveBlanks        : RemoveBlanks : FillStatusBar
            Case %IDM_Trim : TrimContent  : FillStatusBar
            Case %IDM_SortAL, %IDM_SortDL : SortContentByLength(Cb.Ctl) : FillStatusBar
            Case %IDM_SortA, %IDM_SortD, %IDM_SortOther : SortContent(Cb.Ctl) : FillStatusBar

            Case %IDM_ClearBoth
               Control Set Text hDlg, %IDC_Source, ""   : FillStatusBar
               Control Set Text hDlg, %IDC_WordList, "" : FillStatusBar
               FillStatusBar

            Case %IDM_TextExt
               Dialog Get Loc hDlg To w,h
               ghHook = SetWindowsHookEx(%WH_CBT, CodePtr(InputBoxProcExt), GetModuleHandle(""), GetCurrentThreadId)
               temp$ = InputBox$("Edit Text File Extension List", "Text File Extensions", FileFilter,w+40,h+150)
               If Len(temp$) Then FileFilter = temp$

            Case %IDM_Stats : TextStatistics

            Case %IDM_Capture
               Sleep 500
               Clipboard Reset
               keybd_event(%VK_SnapShot, 1, 0, 0)  'active dialog

            Case %IDM_Find
               SearchSide = GetFocus
               DisplayFindDialog

            Case %IDM_SelectLibrary      : SelectLibrary
            Case %IDM_RemoveMatching     : RemoveWords 1 : FillStatusBar  '1=matching
            Case %IDM_RemoveNonMatching  : RemoveWords 0 : FillStatusBar   '0=nonmatching

            Case %IDM_SaveAs
               SelectSaveAsFileNameAndSave

            Case %IDM_MatchingLines
               Dialog Get Loc hDlg To w,h
               ghHook = SetWindowsHookEx(%WH_CBT, CodePtr(InputBoxProcExt), GetModuleHandle(""), GetCurrentThreadId)
               temp$ = InputBox$("Enter Text to Match", "Create Matching Line List", MatchTerm,w+40,h+150)
               If Len(temp$) Then MatchTerm = LCase$(temp$) : CreateMatchingList %IDC_Source

            Case %IDM_MatchingWords
               Dialog Get Loc hDlg To w,h
               ghHook = SetWindowsHookEx(%WH_CBT, CodePtr(InputBoxProcExt), GetModuleHandle(""), GetCurrentThreadId)
               temp$ = InputBox$("Enter Text to Match", "Create Matching Word List", MatchTerm,w+40,h+150)
               If Len(temp$) Then MatchTerm = LCase$(temp$) : CreateMatchingList %IDC_WordList

            Case %IDM_MinimalBinary
               MinimalBinary = MinimalBinary Xor 1
               SetMenusAndToolbarButtons

            Case %IDM_SetMinMax
               Dialog Get Loc hDlg To w,h
               ghHook = SetWindowsHookEx(%WH_CBT, CodePtr(InputBoxProcExt), GetModuleHandle(""), GetCurrentThreadId)
               temp$ = InputBox$("Enter Min/Max Word Sizes", "Edit Min/Max Word Size", Str$(MinSize) + Str$(MaxSize),w+40,h+150)
               If Len(temp$) Then
                  temp$ = Shrink$(temp$)
                  MinSize = Val(Parse$(temp$,$Spc,1))
                  MaxSize = Val(Parse$(temp$,$Spc,2))
               End If

            Case %IDM_Reload
               If IsFile(CurrentFileName) Then
                  MousePtr 11
                  LoadFile
                  If AutoCreate Then CreateWordList
                  FillStatusBar
                  Control Set Focus hDlg, %IDC_Source
                  MousePtr 1
               Else
                  MsgBox "No source file specified!", %MB_Ok + %MB_IconInformation, "Reload Source File"
               End If

            Case %IDT_Settings
               Dialog Get Loc hDlg To w,h
               ghHook = SetWindowsHookEx(%WH_CBT, CodePtr(InputBoxProcChar), GetModuleHandle(""), GetCurrentThreadId)
               temp$ = InputBox$("Edit Allowed Character List", "Allowed Character List", AllowedChars,w+40,h+150)
               If Len(temp$) Then AllowedChars = temp$

            Case %IDT_Help       :
               temp$ = "http://www.garybeene.com/sw/gbwordlist.htm"
               iResult = ShellExecute(hDlg, "Open", (temp$), $Nul, $Nul, %SW_ShowNormal)

            Case %IDT_SayList
               OpenSayList

            Case %IDT_Font
               SelectMainFont
               Control Set Font hDlg, %IDC_Source, hFont
               Control Set Font hDlg, %IDC_WordList, hFont
         End Select

      Case %WM_Notify
           nmtb = Cb.LParam
           Select Case @nmtb.hdr.Code
              Case %TBN_DROPDOWN
                 Select Case @nmtb.iItem
                    Case %IDT_Settings
                       Menu Set Text hPopupSettings, ByCmd %IDM_SelectLibrary, "Select Library File  (" + PathName$(Namex,LibraryFileName)+ ")"
                       Call SendMessage(@nmtb.hdr.hwndFrom, %TB_GETRECT, @nmtb.iItem, VarPtr(rc))
                       Call MapWindowPoints(@nmtb.hdr.hwndFrom, %HWND_Desktop, ByVal VarPtr(rc), 2)
                       Call TrackPopupMenu (hPopUpSettings, 0, rc.nLeft, rc.nBottom, 0, CbHndl, ByVal %Null)
                 End Select
           End Select

           Select Case Cb.NmId
               Case %IDT_Open To %IDT_Help
                  Select Case Cb.NmCode
                     Case %TTN_GetDispInfo
                         P = Cb.LParam
                         @P.@lpszText = SetToolTips(Cb.NmId)
                     Case %TBN_DropDown
                        ? "bingo"
               End Select
           End Select
      Case %WM_Size
         Dialog Get Client hDlg To w,h
         Control Set Loc hDlg, %IDC_WordList, w/2+10,55
         Control Set Size hDlg, %IDC_WordList, w/2-20, h-80
         Control Set Size hDlg, %IDC_Source, w/2-20, h-80
   End Select
End Function

Sub CreateWordList
   MousePtr 11
   Local delimiter$, temp$
   delimiter$ = Remove$(Chr$(0 To 255), Any AllowedChars)
   Control Get Text hDlg, %IDC_Source To temp$
   If CaseSensitive = 0 Then temp$ = LCase$(Trim$(temp, Any delimiter$))
   ReDim WordsIn(ParseCount(temp$, Any delimiter$)-1) 'As String
   Parse temp$, WordsIn(), Any delimiter$
   Array Sort WordsIn()
   RemoveDupesAndNumberWords  'per settings
   Control Set Text hDlg, %IDC_WordList, Join$(WordsOut(),$CrLf)
   FillStatusBar
   Control Set Focus hDlg, %IDC_WordList
   MousePtr 1
End Sub

Sub RemoveDupesAndNumberWords
   Local iPos,i,iStart,iCount,iLength As Long, uniqueword As String
   ReDim WordsOut(UBound(WordsIn))

   'Always skip empty words
   For i = 0 To UBound(WordsIn)
      If Len(WordsIn(i)) Then iStart = i : Exit For
   Next i

   'If AllowNumeric=0 then skip words starting with numbers
   If AllowNumeric=0 Then
      For i = iStart To UBound(WordsIn)
         If InStr("0123456789",Left$(WordsIn(i),1))=0 Then iStart = i : Exit For
      Next i
   End If

   'starting with first non-"" word, put unique members in WordsOut
   uniqueword = wordsin(iStart) : iCount = 1
   For i = iStart+1 To UBound(WordsIn)
      If (AllowNumeric = 0) And InStr("0123456789",Left$(WordsIn(i),1)) Then Iterate For
      iLength = Len(WordsIn(i))
      If (iLength < MinSize) Or (iLength > MaxSize) Then Iterate For
      If WordsIn(i) <> WordsIn(i-1) Then
         WordsOut(iPos) = IIf$(linenumbers, Format$(iPos+1,"00000  "),"") + IIf$(wordcount, Format$(iCount,"00000  "),"") + uniqueword
         uniqueword = wordsin(i)
         Incr iPos
         iCount = 1
      Else
         Incr iCount
      End If
   Next i
   WordsOut(iPos) = IIf$(linenumbers, Format$(iPos+1,"00000  "),"") + IIf$(wordcount, Format$(iCount,"00000  "),"") + uniqueword
   ReDim Preserve WordsOut(iPos)
End Sub

Sub SelectAndLoadFile
    Local title$, startfolder$, filter$, startfile$, defaultext$, flags&, filevar$, countvar&
    title$ = ""    'caption title. if "", then "Open" is displayed
    filter$ = "Text Files" + $Nul + FileFilter + $Nul   ' or filter$ = CHR$("Text",0,"*.txt",0)
    If CurrentFileName = "<none>" Then CurrentFileName = ""
    startfolder$ = IIf$(Len(CurrentFileName), CurrentFileName, Exe.Path$)     'initial folder to be displayed
    startfile$ = (CurrentFileName)       'name to be used as initial selection
    defaultext$ = "txt"                 'default extension to append to selection if user does not enter it
    flags& = %OFN_Explorer Or %OFN_FileMustExist Or %OFN_HideReadOnly
    Display Openfile hDlg, 100, 100, title$, startfolder$, filter$, startfile$, defaultext$, flags& To filevar$, countvar&
    If Len(filevar$) Then
       MousePtr 11
       Control Set Text hDlg, %IDC_Source, ""
       Dialog ReDraw hDlg
       CurrentFileName = filevar$
       LoadFile
       MousePtr 1
    End If
    PostMessage GetDlgItem(hDlg, %IDC_Source), %EM_SETSEL, -1, 0   'remove highlighting on cancel load
End Sub

Sub SaveSession
   Local temp$
   Control Get Text hDlg, %IDC_Source To temp$
   Open Exe.Path$ + "gbwordlist_source.txt" For Output As #1
   Print #1, temp$;
   Close #1

   Control Get Text hDlg, %IDC_WordList To temp$
   Open Exe.Path$ + "gbwordlist_wordlist.txt" For Output As #1
   Print #1, temp$;
   Close #1
End Sub

Sub LoadPreviousSession
    Local temp$, fName$
    fName$ = Exe.Path$ + "gbwordlist_source.txt"
    If IsFile(fName$) Then
       Open fName$ For Binary As #1
       Get$ #1, Lof(1), temp$
       Close #1
       Control Set Text hDlg, %IDC_Source, temp$
    End If
    fName$ = Exe.Path$ + "gbwordlist_wordlist.txt"
    If IsFile(fName$) Then
       Open fName$ For Binary As #1
       Get$ #1, Lof(1), temp$
       Close #1
       Control Set Text hDlg, %IDC_WordList, temp$
    End If
End Sub

Sub Settings_INI(Task$)
   Local x As Long, y As Long
   Local xResult, yResult, temp As WStringZ*%Max_Path

   INIFileName = Exe.Path$ + "gbwordlist.ini"

   If Task$ = "get" Then
      'get dialog top/left from INI file and use to set Dialog location
      Getprivateprofilestring "All", "Left", "300", xResult, %Max_Path, INIFileName
      Getprivateprofilestring "All", "Top", "300", yResult, %Max_Path, INIFileName
      Dialog Set Loc hDlg, Val(xResult), Val(yResult)   'left/top

      'get dialog width/height from INI file and use to set Dialog size
      GetPrivateProfileString "All", "Width", "495", xResult, %Max_Path, INIFileName
      GetPrivateProfileString "All", "Height", "300", yResult, %Max_Path, INIFileName
      Dialog Set Size hDlg,Val(xResult), Val(yResult)   'width/height

      'get value for string variables
      Getprivateprofilestring "All", "FileFilter", "*.gbs;*.log;*.bas;*.txt;*.inc;*.ini;*.xml", FileFilter, %Max_Path, INIFileName
      Getprivateprofilestring "All", "AllowedChars", Chr$(37,45,46,58,95,48 To 57,65 To 90,97 To 122), AllowedChars, %Max_Path, INIFileName
      Getprivateprofilestring "All", "CurrentFileName", "<none>", CurrentFileName, %Max_Path, INIFileName
      Getprivateprofilestring "All", "FontName", "MS Sans Serif", FontName, %Max_Path, INIFileName
      Getprivateprofilestring "All", "FileExtMS", ".docx", FileExtMS, %Max_Path, INIFileName   'covers doc and docx
      Getprivateprofilestring "All", "FileExtHTM", ".html", FileExtHTM, %Max_Path, INIFileName  'covers htm and html
      Getprivateprofilestring "All", "FileExtBIN", ".exe .bin .dll", FileExtBIN, %Max_Path, INIFileName  'covers htm and html
      Getprivateprofilestring "All", "SearchTerm", "", SearchTerm, %Max_Path, INIFileName
      Getprivateprofilestring "All", "MatchTerm", "", MatchTerm, %Max_Path, INIFileName
      Getprivateprofilestring "All", "LibraryFileName", Exe.Path$ + "library_files\library.txt", LibraryFileName, %Max_Path, INIFileName

      'get value for numeric variables
      Getprivateprofilestring "All", "WordCount", "0", temp, %Max_Path, INIFileName:  WordCount = Val(temp)
      Getprivateprofilestring "All", "CaseSensitive", "0", temp, %Max_Path, INIFileName:  CaseSensitive = Val(temp)
      Getprivateprofilestring "All", "AllowNumeric", "0", temp, %Max_Path, INIFileName:  AllowNumeric = Val(temp)
      Getprivateprofilestring "All", "LineNumbers", "0", temp, %Max_Path, INIFileName:  LineNumbers = Val(temp)
      Getprivateprofilestring "All", "FontSize", "8", temp, %Max_Path, INIFileName:  FontSize = Val(temp)
      Getprivateprofilestring "All", "FontAttr", "0", temp, %Max_Path, INIFileName:  FontAttr = Val(temp)
      Getprivateprofilestring "All", "AutoCreate", "0", temp, %Max_Path, INIFileName:  AutoCreate = Val(temp)
      Getprivateprofilestring "All", "MinimalBinary", "0", temp, %Max_Path, INIFileName:  MinimalBinary = Val(temp)
      Getprivateprofilestring "All", "SearchSensitive", "0", temp, %Max_Path, INIFileName:  SearchSensitive = Val(temp)
      Getprivateprofilestring "All", "TabConversion", "4", temp, %Max_Path, INIFileName:  TabConversion = Val(temp)
      Getprivateprofilestring "All", "ShowCFN", "0", temp, %Max_Path, INIFileName:  ShowCFN = Val(temp)
      Getprivateprofilestring "All", "MinSize", "0", temp, %Max_Path, INIFileName:  MinSize = Val(temp)
      Getprivateprofilestring "All", "MaxSize", "99999", temp, %Max_Path, INIFileName:  MaxSize = Val(temp)
   End If

   If Task$ = "save" Then
      'save dialog size/location unless minimized or maximized
      If IsFalse(IsIconic(hDlg) Or IsZoomed(hDlg)) Then
         Dialog Get Loc hDlg To x,y
         WritePrivateProfileString "All", "Left", Str$(x), INIFileName
         WritePrivateProfileString "All", "Top", Str$(y), INIFileName
         Dialog Get Size hDlg To x,y
         WritePrivateProfileString "All", "Width", Str$(x), INIFileName
         WritePrivateProfileString "All", "Height", Str$(y), INIFileName
      End If
      'save string variables
      WritePrivateProfileString "All", "FileFilter",FileFilter, INIFileName
      WritePrivateProfileString "All", "AllowedChars",AllowedChars, INIFileName
      WritePrivateProfileString "All", "CurrentFileName",CurrentFileName, INIFileName
      WritePrivateProfileString "All", "FontName",FontName, INIFileName
      WritePrivateProfileString "All", "FileExtMS",FileExtMS, INIFileName
      WritePrivateProfileString "All", "FileExtHTM",FileExtHTM, INIFileName
      WritePrivateProfileString "All", "FileExtBIN",FileExtBIN, INIFileName
      WritePrivateProfileString "All", "SearchTerm",SearchTerm, INIFileName
      WritePrivateProfileString "All", "MatchTerm",MatchTerm, INIFileName
      WritePrivateProfileString "All", "LibraryFileName",LibraryFileName, INIFileName

      'save numeric variables
      WritePrivateProfileString "All", "WordCount", (Str$(WordCount)), INIFileName
      WritePrivateProfileString "All", "CaseSensitive", (Str$(CaseSensitive)), INIFileName
      WritePrivateProfileString "All", "AllowNumeric", (Str$(AllowNumeric)), INIFileName
      WritePrivateProfileString "All", "LineNumbers", (Str$(LineNumbers)), INIFileName
      WritePrivateProfileString "All", "FontSize", (Str$(FontSize)), INIFileName
      WritePrivateProfileString "All", "FontAttr", (Str$(FontAttr)), INIFileName
      WritePrivateProfileString "All", "AutoCreate", (Str$(AutoCreate)), INIFileName
      WritePrivateProfileString "All", "MinimalBinary", (Str$(MinimalBinary)), INIFileName
      WritePrivateProfileString "All", "SearchSensitive", (Str$(SearchSensitive)), INIFileName
      WritePrivateProfileString "All", "TabConversion", (Str$(TabConversion)), INIFileName
      WritePrivateProfileString "All", "ShowCFN", (Str$(ShowCFN)), INIFileName
      WritePrivateProfileString "All", "MinSize", (Str$(MinSize)), INIFileName
      WritePrivateProfileString "All", "MaxSize", (Str$(MaxSize)), INIFileName
   End If
End Sub

Function NewProc(ByVal hWnd As Long, ByVal Msg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
   Local x As Long, y As Long
   Select Case Msg
      Case %WM_LButtonUp, %WM_KeyUp
         FillStatusBar
      Case %WM_ContextMenu
         SetFocus wParam
         x = Lo(Integer,lParam) : y = Hi(Integer, lParam)    'WM_ContextMenu returns xy coordinates of mouse
         TrackPopupMenu hContext, %TPM_LeftAlign, x, y, 0, hDlg, ByVal 0   'put context menu where mouse is
         Function = 0 : Exit Function
      Case %WM_GETDLGCODE
'         If lParam = %NULL Then
'            x = CallWindowProc(OldProc&, hWnd, Msg, wParam, lParam)
'            Function = x Xor %DlgC_HasSetSel
'            Exit Function
'         End If
   End Select
   Function = CallWindowProc(OldProc&, hWnd, Msg, wParam, lParam)
End Function

Sub CreateCustomPopUpMenu
   Menu New PopUp To hContext
   Menu Add String, hContext, "Copy",   %IDM_Copy,  %MF_Enabled
   Menu Add String, hContext, "Cut",    %IDM_Cut,  %MF_Enabled
   Menu Add String, hContext, "Paste",  %IDM_Paste,  %MF_Enabled
   Menu Add String, hContext, "Delete", %IDM_Delete,  %MF_Enabled
   Menu Add String, hContext, "-", 0, 0
   Menu Add String, hContext, "Clear", %IDM_Clear,  %MF_Enabled
   Menu Add String, hContext, "Clear (Both)", %IDM_ClearBoth,  %MF_Enabled
   Menu Add String, hContext, "-", 0, 0
   Menu Add String, hContext, "Trim Spaces", %IDM_Trim,  %MF_Enabled
   Menu Add String, hContext, "Remove Blank Lines", %IDM_RemoveBlanks,  %MF_Enabled
   Menu Add String, hContext, "Convert TABs to Spaces", %IDM_ConvertTABs,  %MF_Enabled
   Menu Add String, hContext, "-", 0, 0
   Menu Add String, hContext, "Sort Ascending", %IDM_SortA,  %MF_Enabled
   Menu Add String, hContext, "Sort Descending", %IDM_SortD,  %MF_Enabled
   Menu Add String, hContext, "-", 0, 0
   Menu Add String, hContext, "Sort Ascending (by Length)", %IDM_SortAL,  %MF_Enabled
   Menu Add String, hContext, "Sort Descending (by Length)", %IDM_SortDL,  %MF_Enabled
   Menu Add String, hContext, "-", 0, 0
   Menu Add String, hContext, "Convert To Upper Case", %IDM_UCase,  %MF_Enabled
   Menu Add String, hContext, "Convert To Lower Case", %IDM_LCase,  %MF_Enabled
   Menu Add String, hContext, "Convert To MCase", %IDM_MCase,  %MF_Enabled
   Menu Add String, hContext, "-", 0, 0
   Menu Add String, hContext, "Search", %IDM_Find,  %MF_Enabled
   Menu Add String, hContext, "-", 0, 0
   Menu Add String, hContext, "Reload Source File", %IDM_Reload,  %MF_Enabled
   Menu Add String, hContext, "Save As", %IDM_SaveAs,  %MF_Enabled
   Menu Add String, hContext, "-", 0, 0
   Menu Add String, hContext, "Statistics", %IDM_Stats,  %MF_Enabled
End Sub

Sub CreateToolbar
    ImageList New Icon 24,24,24,10 To hImageList
    ImageList Add Icon hImageList, "opentextfile" '1
    ImageList Add Icon hImageList, "createlist"   '2
    ImageList Add Icon hImageList, "copylist"     '3
    ImageList Add Icon hImageList, "wordcount"    '4
    ImageList Add Icon hImageList, "casesensitive"'5
    ImageList Add Icon hImageList, "allownumeric" '6
    ImageList Add Icon hImageList, "settings"     '7
    ImageList Add Icon hImageList, "help"         '8
    ImageList Add Icon hImageList, "fonttype"     '9
    ImageList Add Icon hImageList, "linenumber"   '10
    ImageList Add Icon hImageList, "saylist"   '11

    Control Add Toolbar, hDlg, %IDC_Toolbar,"", 0,0,0,0, %TbStyle_Tooltips Or %TbStyle_Flat Or %WS_Child
    Control Handle hDlg, %IDC_Toolbar To hToolbar
    SendMessage hToolbar, %TB_SETEXTENDEDSTYLE, 0, %TBSTYLE_EX_DRAWDDARROWS

    Toolbar Set ImageList hDlg, %IDC_Toolbar, hImageList, 0     'default imagelist
    Toolbar Add Button  hDlg, %IDC_Toolbar, 1, %IDT_Open,  %TbStyle_Button, "Open"
    Toolbar Add Button  hDlg, %IDC_Toolbar, 2, %IDT_Create,  %TbStyle_Button, "Create"
    Toolbar Add Separator hDlg, %IDC_Toolbar, 5
    Toolbar Add Button  hDlg, %IDC_Toolbar, 3, %IDT_Copy,  %TbStyle_Button, "Copy"
    Toolbar Add Separator hDlg, %IDC_Toolbar, 5
    Toolbar Add Button  hDlg, %IDC_Toolbar, 5, %IDT_CaseSensitive,  %TbStyle_Check, " Case "
    Toolbar Add Button  hDlg, %IDC_Toolbar, 6, %IDT_AllowNumeric,  %TbStyle_Check, "Numeric"
    Toolbar Add Button  hDlg, %IDC_Toolbar, 4, %IDT_WordCount,  %TbStyle_Check, "Count"
    Toolbar Add Button  hDlg, %IDC_Toolbar, 10, %IDT_LineNumbers,  %TbStyle_Check, "Line#"
    Toolbar Add Separator hDlg, %IDC_Toolbar, 5
    Toolbar Add Button  hDlg, %IDC_Toolbar, 11, %IDT_SayList,  %TbStyle_Button, "SayList"
    Toolbar Add Button  hDlg, %IDC_Toolbar, 9, %IDT_Font,  %TbStyle_Button, "Font"
    Toolbar Add Button  hDlg, %IDC_Toolbar, 7, %IDT_Settings,  %TbStyle_Button Or %TbStyle_DropDown, "Settings"
    Toolbar Add Separator hDlg, %IDC_Toolbar, 5
    Toolbar Add Button  hDlg, %IDC_Toolbar, 8, %IDT_Help,  %TbStyle_Button, "Help"

    Menu New PopUp To hPopupSettings
    Menu Add String, hPopupSettings, "Auto-Create", %IDM_AutoCreate, %MF_Enabled
    Menu Add String, hPopupSettings, "Case Sensitive Search/Sort", %IDM_SearchSensitive, %MF_Enabled
    Menu Add String, hPopupSettings, "Show File Name in Caption", %IDM_ShowCFN, %MF_Enabled
    Menu Add String, hPopupSettings, "Minimal Binary", %IDM_MinimalBinary, %MF_Enabled
    Menu Add String, hPopupSettings, "-",0,0
    Menu Add String, hPopupSettings, "Edit Word Character List", %IDT_Settings, %MF_Enabled
    Menu Add String, hPopupSettings, "Edit Text File Extensions", %IDM_TextExt, %MF_Enabled
    Menu Add String, hPopupSettings, "Edit Min/Max Word Size", %IDM_SetMinMax, %MF_Enabled
    Menu Add String, hPopupSettings, "-",0,0
    Menu Add String, hPopupSettings, "Select Library File", %IDM_SelectLibrary, %MF_Enabled
    Menu Add String, hPopupSettings, "Remove Library Words", %IDM_RemoveMatching, %MF_Enabled
    Menu Add String, hPopupSettings, "Keep Library Words", %IDM_RemoveNonMatching, %MF_Enabled
    Menu Add String, hPopupSettings, "-",0,0
    Menu Add String, hPopupSettings, "Create Matching Line List", %IDM_MatchingLines, %MF_Enabled
    Menu Add String, hPopupSettings, "Create Matching Word List", %IDM_MatchingWords, %MF_Enabled
    Menu Add String, hPopupSettings, "-",0,0
    Menu Add String, hPopupSettings, "Capture Dialog Image", %IDM_Capture, %MF_Enabled

End Sub

Function SetToolTips(cID As Long) As String
   Select Case cID          'or this:   @P.hdr.idFrom
      Case %IDT_Open       : Function = "Select and Open Text File"
      Case %IDT_Create     : Function = "Create Word List"
      Case %IDT_Copy       : Function = "Copy Word List (All if no Selection"
      Case %IDT_CaseSensitive : Function = "Case Sensitive Word List"
      Case %IDT_AllowNumeric  : Function = "Show Words That Start With Numbers"
      Case %IDT_WordCount     : Function = "Show Word Count in Word List"
      Case %IDT_Settings      : Function = "Edit Allowed Character List"
      Case %IDT_Font          : Function = "Open Select Font Dialog  (" + FontName + Str$(FontSize) + ")"
      Case %IDT_LineNumbers   : Function = "Add Line Numbers to Word List"
      Case %IDT_SayList       : Function = "Open Word List in gbSayList"
      Case %IDT_Settings      : Function = "Edit Allowed Character List"
      Case %IDT_Help          : Function = "Open OnLine Help"
   End Select
End Function

Function InputBoxProcChar(ByVal nCode As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
   Local szTemp As WStringZ * %Max_Path, cw As CBT_CREATEWND Ptr, cst As CREATESTRUCT Ptr
   Function = CallNextHookEx(ByVal ghHook, ByVal nCode, ByVal wParam, ByVal lParam)
   If nCode < 0 Then Exit Function
   If nCode = %HCBT_ACTIVATE Then UnhookWindowsHookEx ghHook
   If nCode = %HCBT_CREATEWND Then
      cw = lParam         ' Get pointer to CBT_CREATEWND struct so we can...    TT: Nick Melnick
      cst = @cw.lpcs      ' get a pointer to the CREATESTRUCT struct
      GetClassName wParam, szTemp, %Max_Path      ' for each window / control as it is created
'      If UCase$(szTemp) = "BUTTON" Then @cst.cx = @cst20                           'prompt
      If UCase$(szTemp) = "BUTTON" Then @cst.x = 580                           'ok and cancel
      If UCase$(szTemp) = "STATIC" Then @cst.cy = 20                           'prompt
      If UCase$(szTemp) = "EDIT"   Then @cst.cx = 560 : @cst.y = @cst.y - 130  'textbox
      If UCase$(szTemp) = "EDIT"   Then SetWindowLong wparam, %GWL_Style, GetWindowLong(wParam,%GWL_Style)
      If UCase$(szTemp) = "#32770" Then @cst.cx = 675 : @cst.cy = @cst.cy - 130                'dialog
   End If
End Function

Function InputBoxProcExt(ByVal nCode As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
   Local szTemp As WStringZ * %Max_Path, cw As CBT_CREATEWND Ptr, cst As CREATESTRUCT Ptr
   Function = CallNextHookEx(ByVal ghHook, ByVal nCode, ByVal wParam, ByVal lParam)
   If nCode < 0 Then Exit Function
   If nCode = %HCBT_ACTIVATE Then UnhookWindowsHookEx ghHook
   If nCode = %HCBT_CREATEWND Then
      cw = lParam         ' Get pointer to CBT_CREATEWND struct so we can...    TT: Nick Melnick
      cst = @cw.lpcs      ' get a pointer to the CREATESTRUCT struct
      GetClassName wParam, szTemp, %Max_Path      ' for each window / control as it is created
'      If UCase$(szTemp) = "BUTTON" Then @cst.cx = @cst20                           'prompt
      If UCase$(szTemp) = "BUTTON" Then @cst.x = 310                           'ok and cancel
      If UCase$(szTemp) = "STATIC" Then @cst.cy = 20                           'prompt
      If UCase$(szTemp) = "EDIT"   Then @cst.cx = 290 : @cst.y = @cst.y - 130  'textbox
      If UCase$(szTemp) = "EDIT"   Then SetWindowLong wparam, %GWL_Style, GetWindowLong(wParam,%GWL_Style)
      If UCase$(szTemp) = "#32770" Then @cst.cx = 405 : @cst.cy = @cst.cy - 130                'dialog
   End If
End Function

Sub SelectMainFont
   Local fName As String, fPoints, fStyle, fColor, CharSet, Style As Long
   Style = %CF_ScreenFonts Or %CF_ForceFontExist Or %CF_NoScriptSel Or %CF_NoSimulations 'Or IIf(FixedPitch,%CF_FixedPitchOnly,0)
   ghHook = SetWindowsHookEx(%WH_CBT, CodePtr(FontDialogProc), GetModuleHandle(""), GetCurrentThreadId)
   Display Font hDlg, 100,100, FontName, FontSize, FontAttr, Style To fName, fPoints, fStyle, fColor, CharSet
   If Len(fName) Then
      FontName = fName : FontSize = fPoints : FontAttr = fStyle
      Font New FontName, FontSize, FontAttr To hFont
   End If
End Sub

Function FontDialogProc(ByVal nCode As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
    Local szTemp As WStringZ * %Max_Path, cw As CBT_CREATEWND Ptr, cst As CREATESTRUCT Ptr
    Function = CallNextHookEx(ByVal ghHook, ByVal nCode, ByVal wParam, ByVal lParam)
    If nCode < 0 Then Exit Function
    If nCode = %HCBT_ACTIVATE Then UnhookWindowsHookEx ghHook
    If nCode = %HCBT_CREATEWND Then
        cw = lParam         ' Get pointer to CBT_CREATEWND struct so we can...    TT: Nick Melnick
        cst = @cw.lpcs      ' get a pointer to the CREATESTRUCT struct
        GetClassName wParam, szTemp, %Max_Path      ' for each window / control as it is created
        If UCase$(szTemp) = "#32770" Then @cst.cy = @cst.cy - 165 : @cst.cx = @cst.cx - 10  'dialog
    End If
End Function

Sub SetMenusAndToolbarButtons
   'Toolbar Buttons
   Toolbar Set State hDlg, %IDC_Toolbar, ByCmd %IDT_WordCount, %TBState_Checked * WordCount Or %TBState_Enabled
   Toolbar Set State hDlg, %IDC_Toolbar, ByCmd %IDT_CaseSensitive, %TBState_Checked * CaseSensitive Or %TBState_Enabled
   Toolbar Set State hDlg, %IDC_Toolbar, ByCmd %IDT_AllowNumeric, %TBState_Checked * AllowNumeric Or %TBState_Enabled
   Toolbar Set State hDlg, %IDC_Toolbar, ByCmd %IDT_LineNumbers, %TBState_Checked * LineNumbers Or %TBState_Enabled
   'Menus
   Menu Set State hPopupSettings, ByCmd %IDM_AutoCreate, AutoCreate * 8
   Menu Set State hPopupSettings, ByCmd %IDM_SearchSensitive, SearchSensitive * 8
   Menu Set State hPopupSettings, ByCmd %IDM_ShowCFN, ShowCFN * 8
   Menu Set State hPopupSettings, ByCmd %IDM_MinimalBinary, MinimalBinary * 8
   'CheckBox (Search Dialog)
   Control Set Check hSearch, %IDS_SearchSensitive, SearchSensitive
End Sub


Sub TextStatistics
   MousePtr 11
   Dim Letter() As Long, Number() As Long, T() As String
   Local iLineFeeds As Long, iTotalChars As Long, temp$, i As Long
   Local iSpaces As Long, iOther As Long, iLetters As Long, iScaleFactor As Long
   Local iLong As Long, iShort As Long, iLines As Long, iNumbers As Long, iTotal As Long

   Dim Letter(26), Number(10)

   Control Get Text hDlg, GetDlgCtrlID(GetFocus) To temp$
   If Len(temp$) = 0 Then
       MsgBox  "No content!", %MB_Ok + %MB_IconExclamation, IIf$(GetDlgCtrlID(GetFocus)=%IDC_Source,"Source ","Word List ")+"Statistics"
       Exit Sub
   End If
   iLines = ParseCount(temp$, $CrLf)
   Dim T(iLines-1) : Parse temp$, T(), $CrLf

   'look for longest/shortest lines
   iLong = 0 :  iShort = 99999999
   For i = 0 To UBound(T)
       If iLong < Len(T(i)) Then iLong = Len(T(i))
       If iShort > Len(T(i)) Then iShort = Len(T(i))
   Next i

   'get distribution of each number/letter
   For i = 48 To 57  : Number(i-47) = Number(i-47) + Tally(temp$, Chr$(i))  : Next i  ' 0-9
   For i = 97 To 122 : Letter(i-96) = Letter(i-96) + Tally(temp$, Chr$(i))  : Next i  ' a-z
   For i = 65 To 90  : Letter(i-64) = Letter(i-64) + Tally(temp$, Chr$(i))  : Next i  ' A-Z

   iSpaces = Tally(temp$, " ")
   iLineFeeds = Tally(temp$, $CrLf)
   iTotalChars = Len(temp$)

   For i = 1 To 26: iLetters = iLetters + Letter(i) : Next i
   For i = 1 To 10: iNumbers = iNumbers + Number(i) : Next i

   iOther = iTotalChars - iSpaces - iLineFeeds - iLetters - iNumbers

   'set message
   temp = "Number lines: " &  Format$(iLines,"###,###,###0") & $CrLf
   temp = temp & "Shortest Line: " & Str$(iShort) & $CrLf
   temp = temp & "Longest line: " & Str$(iLong) & $CrLf
   temp = temp & "Average Line Length: " & Str$(Int(iTotalChars / iLines)) & $CrLf & $CrLf
   temp = temp & "Characters: " & Format$(iTotalChars,"###,###,###0") & $CrLf
   temp = temp & "Letters: " &  Format$(iLetters,"###,###,###0") & $CrLf
   temp = temp & "Numbers: " &  Format$(iNumbers,"###,###,###0") & $CrLf
   temp = temp & "Spaces: " &  Format$(iSpaces,"###,###,###0") & $CrLf
   temp = temp & "$CRLF: " &  Format$(iLineFeeds,"###,###,###0") & $CrLf
   temp = temp & "Other: " &  Format$(iOther,"###,###,###0") & $CrLf & $CrLf

   'get 'graph' scale factor
   Select Case iLetters + iNumbers
       Case Is < 1000 :   iScaleFactor = 100
       Case Is < 5000 :   iScaleFactor = 200
       Case Is < 10000:   iScaleFactor = 300
       Case Else :        iScaleFactor = 400
   End Select

   iTotal = iLetters + iNumbers
   If iLetters <> 0 Then
       For i = 1 To 26
           temp = temp & Chr$(i + 96) & ": " & Str$(Letter(i)) & String$(iScaleFactor * (Letter(i) / iTotal), "*") & $CrLf
       Next i
   End If
   If iNumbers <> 0 Then
       For i = 1 To 10
           temp = temp & Chr$(i + 47) & ": " & Str$(Number(i)) & String$(iScaleFactor * (Number(i) / iTotal), "*") & $CrLf
       Next i
   End If

   MousePtr 1
   MsgBox temp, %MB_Ok + %MB_IconInformation, IIf$(GetDlgCtrlID(GetFocus)=%IDC_Source,"Source ","Word List ")+"Statistics"

End Sub

Function GetDroppedFileName(hDrop As Dword) As String
   'David Gwillim July 2005
   Local fString As WStringZ*%Max_Path, Count As Long
   fString=Space$(%Max_Path)
   Count = DragQueryFile(hDrop,0,fString,Len(fString)-1)  ' put FileName(0) into fString and get character count
   Function = Left$(fString,Count)                        ' put Count chars into result string
End Function

Sub LoadFile
    If IsFalse(IsFile(CurrentFileName)) Then Exit Sub
    Control Set Text hDlg, %IDC_WordList, ""
    Local temp$, delimiter$
    temp$ = LCase$(PathName$(Extn,CurrentFileName))
    Open CurrentFileName For Binary As #1
    Get$ #1, Lof(1), FileContent    'filedata$ will contain $crlf's from the file
    Close #1
    If InStr(LCase$(FileExtMS),temp$) Then
       ExtractMSText   'Word file
       Control Set Text hDlg, %IDC_Source, FileContent
    ElseIf InStr(LCase$(FileExtHTM),temp$) Then
       ExtractHTMLText 'HTML file
       Control Set Text hDlg, %IDC_Source, FileContent
    ElseIf InStr(LCase$(FileExtBin),temp$) Then
       delimiter$ = Remove$(Chr$(0 To 255), Any AllowedChars)
       Replace Any delimiter$ With Space$(Len(delimiter$)) In FileContent
       If MinimalBinary Then FileContent = Shrink$(FileContent)
       Control Set Text hDlg, %IDC_Source, FileContent
    ElseIf InStr(FileFilter,temp$) Then
       'Text file - leave content as is
       Control Set Text hDlg, %IDC_Source, FileContent
    Else
       Beep
       MsgBox "File type not recognized!", %MB_Ok + %MB_IconExclamation, "Dropped File Received"
    End If
End Sub

Sub ExtractMSText
   Local delimiter$
   delimiter$ = Remove$(Chr$(0 To 255), Any AllowedChars)
   Replace Any delimiter$ With Space$(Len(delimiter$)) In FileContent
End Sub

Sub ExtractHTMLText
   'no change at this time
End Sub

Sub BuildAcceleratorTable
   Local c As Long, ac() As ACCELAPI, hAccelerator As Dword  ' for keyboard accelator table values
   Dim ac(13)
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_B : ac(c).cmd   = %IDM_ClearBoth     : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_E : ac(c).cmd   = %IDT_Settings      : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_F : ac(c).cmd   = %IDM_Find          : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_H : ac(c).cmd   = %IDM_SortOther     : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_I : ac(c).cmd   = %IDM_Capture       : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_L : ac(c).cmd   = %IDM_Reload        : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_M : ac(c).cmd   = %IDM_MatchingLines : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_N : ac(c).cmd   = %IDM_MatchingWords : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_S : ac(c).cmd   = %IDM_SaveAs        : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_W : ac(c).cmd   = %IDT_Create        : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_Z : ac(c).cmd   = %IDM_Stats         : Incr c
   ac(c).fvirt = %FVIRTKEY              : ac(c).key   = %VK_F3 : ac(c).cmd  = %IDM_Find          : Incr c
   ac(c).fvirt = %FVIRTKEY              : ac(c).key   = %VK_F1 : ac(c).cmd  = %IDT_Help          : Incr c
   Accel Attach hDlg, AC() To hAccelerator
End Sub

Sub DisplayFindDialog()
   Local h As Long, w As Long
   Dialog Get Client hDlg To h,w
   Dialog New Pixels, hDlg, "Search", 100, 100, 330, 75, %WS_SysMenu Or %WS_Caption Or %WS_ClipChildren To hSearch
   Dialog Set Icon hSearch, "aainfo"

   Control Add CheckBox, hSearch, %IDS_SearchSensitive, "Case Sensitive", 20,45,100,20
   SetMenusAndToolbarButtons

   Control Add Label, hSearch, %IDS_Label, "Find This:", 5, 10, 60, 20
   Control Add TextBox, hSearch, %IDS_SearchTerm, SearchTerm, 60, 10, 185, 20

   Control Add ImgButton, hSearch, %IDS_Forward, "downhand", 260, 10, 25, 25
   Control Add ImgButton, hSearch, %IDS_Backward, "uphand", 295, 10, 25, 25

   Control Add Button, hSearch, %IdOk, "Ok", 200, 230, 20, 20
   Control Add Button, hSearch, %IdCancel, "Cancel", 230, 230, 20, 20
   Control Show State hSearch, %IdOk, %SW_Hide
   Control Show State hSearch, %IdCancel, %SW_Hide

   fDlgShown = 1

   Dialog Show Modeless hSearch Call SearchProc()
   Do                                                                    'because we want to be able
      Dialog DoEvents                                                     'to edit main text while
   Loop Until fDlgShown = 0

End Sub

CallBack Function SearchProc() As Long
   Local iCheck&, x As Long, y As Long
   Select Case Cb.Msg
      Case %WM_SYSCOMMAND
         If (Cb.WParam And &HFFF0) = %SC_Close Then          'trap Alt-F4 and X Button
            Control Set Focus hDlg, %IDC_Source
         End If
      Case %IdCancel
         fDlgShown = 0
         Dialog End hSearch
      Case %WM_Destroy
         fDlgShown = 0
      Case %WM_Command
         Select Case Cb.Ctl
            Case %IdCancel
               Dialog End hSearch
            Case %IDS_Forward, %IdOk    'search forward
               Control Get Text hSearch, %IDS_SearchTerm To SearchTerm
               FindSearchTerm 1  '1 = forward
            Case %IDS_Backward    'search backward
               Control Get Text hSearch, %IDS_SearchTerm To SearchTerm
               FindSearchTerm 0  '0 = backward
            Case %IDS_SearchSensitive
               SearchSensitive = SearchSensitive Xor 1
               SetMenusAndToolbarButtons
         End Select
   End Select
End Function

Sub FindSearchTerm(Flag As Long)  '1=forward 0=backward
   Local temp$, StartPos, EndPos, iPos As Long, sTerm As String
   SendMessage SearchSide, %EM_GetSel, VarPtr(StartPos), VarPtr(EndPos)  'cursor is here

   Control Get Text hDlg, GetDlgCtrlID(SearchSide) To temp$
   sTerm = SearchTerm

   If SearchSensitive = 0 Then temp$ = LCase$(temp$) : sTerm = LCase$(sTerm)

   If Flag Then
      iPos = InStr(EndPos+1, temp$, sTerm)
   Else
      iPos = InStr(StartPos - Len(temp$), temp$, sTerm)
   End If

   If iPos Then
         iPos = SendMessage(SearchSide, %EM_SetSel, iPos-1, iPos-1 + Len(sTerm))
         SendMessage SearchSide, %EM_SCROLLCARET, 0, 0
   Else
      Beep
   End If
End Sub

Sub SelectLibrary
    Local title$, startfolder$, filter$, startfile$, defaultext$, flags&, filevar$, countvar&
    title$ = ""    'caption title. if "", then "Open" is displayed
    filter$ = "Text Files" + $Nul + FileFilter + $Nul   ' or filter$ = CHR$("Text",0,"*.txt",0)
    startfolder$ = LibraryFileName     'initial folder to be displayed
    startfile$ = LibraryFileName       'name to be used as initial selection
    defaultext$ = "txt"                 'default extension to append to selection if user does not enter it
    flags& = %OFN_Explorer Or %OFN_FileMustExist Or %OFN_HideReadOnly
    Display Openfile hDlg, 100, 100, title$, startfolder$, filter$, startfile$, defaultext$, flags& To filevar$, countvar&
    If Len(filevar$) Then LibraryFileName = filevar$
End Sub

Sub RemoveWords(Flag As Long)  '1=remove matching   0=remove non-matching
   MousePtr 11
   Local temp$, library$, i, WordCount As Long

? LibraryFileName
   If IsFalse(IsFile(LibraryFileName)) Then Beep : Exit Sub

   'put library text in string
   Open LibraryFileName For Binary As #1
   Get$ #1, Lof(1), library$
   Close #1
   library$ = $Spc + library$ + $Spc     '
   Replace $CrLf With $Spc In library$   'one long string, each word wrapped in at least 1 space

   'put word list in array
   Control Get Text hDlg, %IDC_WordList To temp$
   WordCount = SendMessage(hWordList, %EM_GetLineCount, 0,0)
   Dim TempWordList(WordCount-1) As String    'create array
   Parse temp$, TempWordList(), $CrLf         'put words into array

   'remove items (set = "") from array according to flag value
   For i = 0 To UBound(TempWordList)
      If InStr(library$, $Spc + TempWordList(i) + $Spc) Then
         'matching
         If Flag = 1 Then TempWordList(i) = ""
      Else
         'not matching
         If Flag = 0 Then TempWordList(I) = ""
      End If
   Next i
   temp$ = Join$(TempWordList(), $CrLf)
   Replace $CrLf + $CrLf With $CrLf In temp$
   temp$ = Trim$(temp$,$CrLf)
   Control Set Text hDlg, %IDC_WordList, temp$
   FillStatusBar
   MousePtr 1
End Sub

Sub SelectSaveAsFileNameAndSave
    'save file to any location
    Local title$, startfolder$, filter$, startfile$, defaultext$, flags&, filevar$, countvar&, iResult&, temp$
    title$ = ""             'caption title. if "", then "Save As" is displayed
    startfolder$ = CurrentFileName   'initial folder to be displayed
    filter$ = "Text Files" + $Nul + FileFilter + $Nul   ' or filter$ = CHR$("Text",0,"*.txt",0)
    startfile$ = CurrentFileName        'name to be used as initial selection
    defaultext$ = "txt"     'default extension to append to selection if user does not enter it
    flags& = %OFN_PathMustExist Or %OFN_Explorer Or %OFN_OverWritePrompt
    Display Savefile hDlg, 100, 100, title$, startfolder$, filter$, startfile$, defaultext$, flags& To filevar$, countvar&
    If Len(filevar$) Then
       'save
       iResult& = GetDlgCtrlID(GetFocus)  'iResult has Control ID
       Control Get Text hDlg, iResult& To temp$
       Open filevar$ For Output As #1
       Print #1, temp$;
       Close #1
       Control Set Focus hDlg, iResult&
       PostMessage GetDlgItem(hDlg, iResult&), %EM_SETSEL, -1, 0   'remove highlighting on startup
    End If
End Sub

Sub SortContent(mCtl As Long)
   MousePtr 11
   Local ctl, iResult As Long, temp$
   'put word list into an array
   ctl = GetDlgCtrlID(GetFocus)
   SortOther = SortOther Xor 1
   iResult = GetDlgCtrlID(GetFocus)  'iResult has Control ID
   Control Get Text hDlg, iResult To temp$
   Dim TempWordList(ParseCount(temp$,$CrLf)-1) As String
   Parse temp$, TempWordList(), $CrLf

   'sort the array
   Select Case mCtl
      Case %IDM_SortA
         If SearchSensitive Then
            Array Sort TempWordList(), Ascend
         Else
            Array Sort TempWordList(), Collate UCase,  Ascend
         End If
      Case %IDM_SortD
         If SearchSensitive Then
            Array Sort TempWordList(),  Descend
         Else
            Array Sort TempWordList(),  Collate UCase, Descend
         End If
      Case %IDM_SortOther
         If SortOther Then
            If SearchSensitive Then
               Array Sort TempWordList(), Ascend
            Else
               Array Sort TempWordList(), Collate UCase,  Ascend
            End If
         Else
            If SearchSensitive Then
               Array Sort TempWordList(), Descend
            Else
               Array Sort TempWordList(), Collate UCase, Descend
            End If
         End If
   End Select
   Control Set Text hDlg, iResult, Join$(TempWordList(), $CrLf)
   MousePtr 1
End Sub


Sub SortContentByLength(mCtl As Long)  'sort by length, then by alpha
   MousePtr 11
   Local ctl, i, iResult As Long, temp$

   'put control content into array
   ctl = GetDlgCtrlID(GetFocus)
   Control Get Text hDlg, ctl To temp$
   iResult = SendMessage(GetFocus, %EM_GetLineCount, 0,0)
   Dim TempWordList(iResult-1) As String    'create array
   Parse temp$, TempWordList(), $CrLf         'put words into array

   'create LONG tag array with length of elements
   Dim WordLength(UBound(TempWordList)) As Long
   For i = 0 To UBound(TempWordList)
      WordLength(i) = Len(TempWordList(i))
   Next i

   'sort the array
   Select Case mCtl
      Case %IDM_SortAL : Array Sort WordLength(), TagArray TempWordList(), Ascend
      Case %IDM_SortDL : Array Sort WordLength(), TagArray TempWordList(), Descend
   End Select

   Control Set Text hDlg, ctl, Join$(TempWordList(), $CrLf)
   MousePtr 1
End Sub

Sub RemoveBlanks
   MousePtr 11
   Local ctl As Long, temp$
   ctl = GetDlgCtrlID(GetFocus)
   Control Get Text hDlg, ctl To temp$
   While InStr(temp$,$CrLf+$CrLf)
      Replace $CrLf + $CrLf With $CrLf In temp$
   Wend
   Control Set Text hDlg, ctl, Trim$(temp$,$CrLf)
   MousePtr 1
End Sub

Sub TrimContent
   MousePtr 11
   Local i,ctl As Long, temp$
   'put control content into array
   ctl = GetDlgCtrlID(GetFocus)
   Control Get Text hDlg, ctl To temp$
   WordCount = SendMessage(GetFocus, %EM_GetLineCount, 0,0)
   Dim TempWordList(WordCount-1) As String    'create array
   Parse temp$, TempWordList(), $CrLf         'put words into array

   'Trim$ each element of wordlist
   For i = 0 To UBound(TempWordList)
      TempWordList(i) = Trim$(TempWordList(i))
   Next i

   'put back into control
   Control Set Text hDlg, ctl, Join$(TempWordList(),$CrLf)
   FillStatusBar
   MousePtr 1
End Sub

Sub ConvertTABs
   MousePtr 11
   Local ctl As Long, temp$
   ctl = GetDlgCtrlID(GetFocus)
   Control Get Text hDlg, ctl To temp$
   Replace $Tab With Space$(TabConversion) In temp$
   Control Set Text hDlg, ctl, temp$  'put back into control
   FillStatusBar
   MousePtr 1
End Sub

Sub OpenSayList
   Local temp$, pID As Dword, x,y As Long
   Dialog Get Loc hDlg To x,y
   Control Get Text hDlg, %IDC_WordList To temp$
   Open Exe.Path$ + "gbsaylist_wordlist.txt" For Output As #1
   Print #1, "gbSayListxy" + Str$(x) + Str$(y)
   Print #1, temp$
   Close #1
   pID = Shell(Exe.Path$ + "gbsaylist.exe")
End Sub

Sub SetCaption
   Dialog Set Text hDlg, "gbWordList" + $ver + "    " + IIf$(ShowCFN,PathName$(Namex,CurrentFileName),"")
End Sub

Sub CreateLibraryFile
   Open Exe.Path$ + "library_files\library.txt" For Output As #1
   Print #1, "This" + $CrLf + "is" + $CrLf + "the" + $CrLf + "library" + $CrLf + "file"
   Close #1
End Sub

Sub FillStatusBar
   'must account for EM_GetLineCount returning 1 even when context is ""
   Local temp$,L$,R$,i,j As Long
   i = SendMessage(hSource, %EM_GetLineCount, 0,0)
   L$ = "Source Lines: " + Format$(i,"###,###,##0")
   If i = 1 Then
      Control Get Text hDlg, %IDC_Source To temp$
      If temp$ = "" Then L$ = "Source Lines: 0"
   End If

   j = SendMessage(hWordList, %EM_GetLineCount, 0,0)
   R$ = "Word List: " + Format$(j,"###,###,##0")
   If j = 1 Then
      Control Get Text hDlg, %IDC_WordList To temp$
      If temp$ = "" Then R$ = "Word List: 0"
   End If

   Statusbar Set Text hDlg, %IDC_StatusBar, 1, 0, L$ + Space$(10) + R$
End Sub

Sub CreateMatchingList(cID As Long)
   Local temp$, i,iPos As Long
   'put source lines in array
   MousePtr 11
   Control Get Text hDlg, cID To temp$
   ReDim WordsIn(ParseCount(temp$, $CrLf)-1) 'As String
   Parse temp$, WordsIn(), $CrLf 'put words in array
   ReDim WordsOut(UBound(WordsIn()))

   'put matching lines in WordsOut
   iPos = -1
   For i = 0 To UBound(WordsIn)
      If InStr(LCase$(WordsIn(i)),MatchTerm) Then
         Incr iPos
         WordsOut(iPos) = WordsIn(i)
      End If
   Next i
   If iPos > -1 Then
      ReDim Preserve WordsOut(iPos)
   Else
      iPos = 0
      WordsOut(iPos) = "No matching lines found!"
   End If

   'display results
   Control Set Text hDlg, %IDC_WordList, Join$(WordsOut(),$CrLf)
   FillStatusBar
   Control Set Focus hDlg, %IDC_WordList
   MousePtr 1
End Sub

Sub ConvertCase(CaseType As Long)
   Local i,ctl,WordCount As Long, hList As Dword, temp$
   'put word list into an array
   ctl = GetDlgCtrlID(GetFocus)
   Control Get Text hDlg, ctl To temp$
   WordCount = SendMessage(IIf(ctl=%IDC_Source,hSource,hWordList), %EM_GetLineCount, 0,0)
   Dim TempWordList(WordCount-1) As String    'create array
   Parse temp$, TempWordList(), $CrLf         'put words into array

   'change case of array elements
   For i = 0 To UBound(TempWordList)
      Select Case CaseType
         Case 1 : TempWordList(i) = UCase$(TempWordList(i))
         Case 2 : TempWordList(i) = LCase$(TempWordList(i))
         Case 3 : TempWordList(i) = MCase$(TempWordList(i))
      End Select
   Next i
   'return the text
   Control Set Text hDlg, ctl, Join$(TempWordList(),$CrLf)
End Sub
